.TH mmread G "May 2000" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
mmread - reads the contents of a Matrix Market file into a sparse or full matrix
.SH CALLING SEQUENCE
.nf
[A,rows,cols,entr,rep,typ,symm] = mmread(file)
.fi
.SH PARAMETERS
.TP
file
: the name of the Matrix Market file
.TP
A
: sparse or full matrix
.TP
rows
: number of rows of the matrix A
.TP
cols
: number of columns of the matrix A
.TP
entr
: number of nonzero entries in the final matrix
.TP
rep
: representation of the Matrix Market format
.LP
  -'coordinate', coordinate sparse storage
.LP
  -'array', dense array storage
.TP
typ
: type of the entries: 'real', 'complex', 'integer', pattern'
.TP
symm
: give some informations about the symmetry of the matrix: 'general', 'symmetric', 'hermitian', 'skew-symmetric'
.SH DESCRIPTION
\fV[A,rows,cols,entr,rep,typ,symm] = mmread(file)\fR reads the contents of the Matrix Market file 'filename'
into the matrix 'A'.  'A' will be either sparse or full, depending on the Matrix Market format indicated by 'coordinate' (coordinate sparse storage), or 'array' (dense array storage). The data will be duplicated as appropriate if symmetry is indicated in the header. Optionally, size information about the matrix can be obtained by using the return values rows, cols, and entries, where entries is the number of nonzero entries in the final matrix. Type information can also be retrieved using the optional return values rep (representation), typ (type), and symm (symmetry).
.LP
.SH EXAMPLE
.nf
The file 'test.mtx' is obtained by downloading one of the matrix, stored in matrix market format, on the Matrix Market home page. 
[A,rows,cols,entr,rep,typ,symm] = mmread('test.mtx')

.fi
.SH AUTHOR
Source given by the Matrix Market web site. Adaptations for Scilab done by Aladin team - 14 May 2001.
.SH SEE ALSO
mmwrite, mminfo